<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.19.2.1.2.5 $
 * $Author: tora60 $
 * $Date: 2009/05/27 23:29:48 $
 */

/**
 * kein Test wegen direktaufruf, weil diese Datei bereits in der mod.php
 * includet wird, wenn die mainfile noch nicht geladen ist und auch keine
 * Fehler verursachen kann
 *
 * zur Kontrollausgabe, um zu sehen, welche Regeln importiert wurden und was
 * in $content steht kann man die Variable "mod_rewrite_check" per GET uebergeben
 */

/**
 * Variablen deklarieren, weil in Funktion includet wird :-(
 */
global $modrew_prepareauto, $modrew_alternate;

/**
 * die URL's automatisch generieren fuer alles was ueber die modules.php laeuft?
 */
$modrew_prepareauto = true;

/**
 * Ansonsten werden nur die Ersetzungen des Array's $replace_arr beachtet und
 * es muss die .htaccess Dateie geaendert bzw. ergaenzt werden. Dieser Teil
 * sollte dann auskommentiert/entfernt werden:
 */
// dynamisches ersetzen in mod.php
// RewriteRule ^([^-]+)-(.+)\.html$ mod.php?$1&________________________$2 [L]
// RewriteRule ^([^-]+)\.html$ mod.php?$1 [L]
/**
 * durch was sollen bei automatischer Ersetzung, die erwuenschten Bindestriche in der URL ersetzt werden?
 */
$modrew_alternate = '~';

/**
 * Alle in dem uebergebenen String enthaltenen Links umschreiben
 */
function mxPrepareModRewrite($content, $homeurl = '')
{
    global $modrew_prepareauto, $modrew_alternate;

    /* wenn kein Content, raus hier */
    if (!$content) {
        return $content;
    }

    $filepath = dirname(__FILE__) . '/rewrite/';

    /* die Regeln importieren */
    static $replace_arr;
    if (!$replace_arr) {
        /**
         * Array mit allen Schluesseln und Werten zum Suchen & ersetzen zurueckgeben
         * der zu suchende regulaere Ausdruck ist der Schluessel des Arrays der
         * ersetzende Wert ist der Wert des Arrays
         */
        @include($filepath . 'global.php');
    }

    /* zur Kontrollausgabe, um zu sehen, welche Regeln importiert wurden und was in $content steht */
    if (isset($_GET['mod_rewrite_check']) && MX_IS_ADMIN) {
        die('<pre>' . print_r($replace_arr, true) . print_r(htmlspecialchars($content), true) . '</pre>');
    }

    if (!empty($replace_arr)) {
        $content = @preg_replace(array_keys($replace_arr), array_values($replace_arr), $content);
    }

    /**
     * nur wenn die Ersetzungen automatisch generiert werden sollen
     * $modrew_prepareauto muss dazu auf TRUE gesetzt werden
     */
    if ($modrew_prepareauto && $content) {
        $customfile = realpath($filepath . 'custom.php');

        /* ab hier werden die Ersetzungen automatisch generiert, nach Moeglichkeit hier nichts aendern ! */
        $pattern = '!(<a(?:[^>]+)href=["\']|<link>)(?:' . preg_quote(PMX_HOME_URL . '/', '!') . ')?modules\.php\?((?:[[:alnum:]\=&_.;]|&amp;)+)(#[^"\']+)?(["\']|</link>)!i';
        if (!preg_match_all($pattern, $content, $matches)) {
            return $content;
        }

        /* wenn url als Prefix angegeben, diese korrigieren */
        if ($homeurl) {
            $homeurl = trim($homeurl, ' /') . '/';
        }

        /* $replaces initialisieren */
        $replaces = array();

        foreach($matches[2] as $i => $value) {
            /* gewuenschte Bindestriche ersetzen */
            $value = str_replace(array('-', '&amp;'), array($modrew_alternate, '&'), $value);

            /* den alten Wert zwischenspeichern, der wird spter ersetzt ;) */
            $old[$i] = $matches[0][$i];

            /* den gefundenen Querystring aufsplitten */
            parse_str($value, $para);

            /* den Modulnamen gesondert behandeln */
            if (array_key_exists('name', $para)) {
                $name = $para['name'];
                unset ($para['name']);
            } else {
                /* wenn kein Modulname vorhanden, weiter... */
                continue;
            }

            /* unntige Parameter entfernen */
            if (array_key_exists('op', $para) && $para['op'] === 'modload') {
                unset ($para['op']);
            }
            if (array_key_exists('file', $para) && $para['file'] === 'index') {
                unset ($para['file']);
            }

            /* URL neu zusammensetzen, Modulnamen zuerst */
            $parts = array(0 => $name);

            /* wenn das array jetzt schon leer ist, sind keine weiteren Parameter vorhanden, also gleich weiter */
            if ($para) {
                foreach ($para as $key => $value) {
                    $parts[] = $key . '-' . $value;
                }
                if ($customfile) {
                    /* das Array fr die individuelle Modulersetzung generieren */
                    $customarray[$name][$old[$i]] = $para;
                    $customarray[$name][$old[$i]]['prefix'] = $matches[1][$i];
                    $customarray[$name][$old[$i]]['suffix'] = $matches[3][$i] . $matches[4][$i];
                }
            }
            $newurl = implode('-', $parts) . '.html';

            /* Extralange Parameter ignorieren */
            if (strlen($newurl) < 255) {
                // durch das verwenden von $old als Schlssel, wird das Array gleich unique
                $replaces[$old[$i]] = $matches[1][$i] . $homeurl . $newurl . $matches[3][$i] . $matches[4][$i];
            }
        }

        if ($replaces) {
            if ($customfile) {
                @include($customfile);
            }
            $content = str_replace(array_keys($replaces), array_values($replaces), $content);
        }
    }
    return $content;
}

/**
 * Die per umgeschriebener URL dem Script uebergebene Request Parameter
 * wieder in eine verwendbare Form bringen
 */
function mxUndoModRewrite()
{
    global $modrew_alternate, $PHP_SELF;

    $name = '';
    $get = array();
    if (strpos($_SERVER['QUERY_STRING'], '&________________________') === false) {
        $name = str_replace('..', '', $_SERVER['QUERY_STRING']);
    } else {
        list($name, $querystring) = explode('&________________________', $_SERVER['QUERY_STRING']);
        $che = explode('-', $querystring);
        $che = array_chunk($che, 2);
        foreach($che as $part) {
            $key = @str_replace($modrew_alternate, '-', $part[0]);
            $value = @str_replace($modrew_alternate, '-', $part[1]);
            $get[$key] = $value;
        }
    }

    $path = PMX_REAL_BASE_DIR . '/modules/';
    if ($name != 'mxcredit' && !file_exists($path . $name . '/.')) {
        switch (true) {
            case file_exists($path . ucfirst($name) . '/.'):
                $name = ucfirst($name);
                break;
            case file_exists($path . strtolower($name) . '/.'):
                $name = strtolower($name);
                break;
            case file_exists($path . strtoupper($name) . '/.'):
                $name = strtoupper($name);
                break;
            case file_exists($path . ucwords($name) . '/.'):
                $name = ucwords($name);
                break;
            default:
                header('HTTP/1.1 301 Moved Permanently');
                header("Refresh: 2;url=./?moderror=" . urlencode($name));
        }
    }

    $tmp = str_replace('.', '_', $querystring); // Punkte werden im Arrayschluessel als Unterstrich umgewandelt, deswegen hier ersetzen (z.B. $file in mxBoard)
    unset($_GET['name'], $_REQUEST['name'], $get['name'], 
          $_GET[$name], $_REQUEST[$name], $get[$name],
          $_GET['________________________' . $tmp], $_REQUEST['________________________' . $tmp]
          );

    $_GET = array_merge(array('name' => $name), $get, $_GET);

    foreach ($_GET as $key => $value) {
        $parts[$key] = "{$key}={$value}";
    }
    $querystring = implode('&', $parts);

    $_SERVER['QUERY_STRING'] = $querystring;
    $_SERVER['SCRIPT_FILENAME'] = dirname($_SERVER['SCRIPT_FILENAME']) . '/modules.php';
    $_SERVER['PHP_SELF'] = dirname($_SERVER['PHP_SELF']) . '/modules.php';
    $_SERVER['SCRIPT_NAME'] = $_SERVER['PHP_SELF'];
    if (isset($PHP_SELF)) {
        $PHP_SELF = $_SERVER['PHP_SELF'];
    }
    $_SERVER['REQUEST_URI'] = $_SERVER['PHP_SELF'] . '?' . $querystring;
}

?>